(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/material/dialog'), require('@angular/material/card'), require('@angular/material/form-field'), require('@angular/material/select'), require('@angular/material/core'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/input'), require('@angular/common'), require('@angular/material/slide-toggle'), require('@angular/material/tooltip'), require('@angular/material/grid-list'), require('@angular/router'), require('@angular/cdk/bidi'), require('@angular/material/divider'), require('@angular/material/radio')) :
    typeof define === 'function' && define.amd ? define('ag-form-builder', ['exports', '@angular/core', '@angular/forms', '@angular/material/dialog', '@angular/material/card', '@angular/material/form-field', '@angular/material/select', '@angular/material/core', '@angular/material/button', '@angular/material/icon', '@angular/material/input', '@angular/common', '@angular/material/slide-toggle', '@angular/material/tooltip', '@angular/material/grid-list', '@angular/router', '@angular/cdk/bidi', '@angular/material/divider', '@angular/material/radio'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ag-form-builder'] = {}, global.ng.core, global.ng.forms, global.ng.material.dialog, global.ng.material.card, global.ng.material.formField, global.ng.material.select, global.ng.material.core, global.ng.material.button, global.ng.material.icon, global.ng.material.input, global.ng.common, global.ng.material.slideToggle, global.ng.material.tooltip, global.ng.material.gridList, global.ng.router, global.ng.cdk.bidi, global.ng.material.divider, global.ng.material.radio));
}(this, (function (exports, i0, i1, i1$1, i3$1, i2, i5, i6, i3, i4, i7, i8, i7$1, i11, i7$2, i1$2, i4$1, divider, radio) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);
    var i3__namespace$1 = /*#__PURE__*/_interopNamespace(i3$1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i5__namespace = /*#__PURE__*/_interopNamespace(i5);
    var i6__namespace = /*#__PURE__*/_interopNamespace(i6);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i7__namespace = /*#__PURE__*/_interopNamespace(i7);
    var i8__namespace = /*#__PURE__*/_interopNamespace(i8);
    var i7__namespace$1 = /*#__PURE__*/_interopNamespace(i7$1);
    var i11__namespace = /*#__PURE__*/_interopNamespace(i11);
    var i7__namespace$2 = /*#__PURE__*/_interopNamespace(i7$2);
    var i1__namespace$2 = /*#__PURE__*/_interopNamespace(i1$2);
    var i4__namespace$1 = /*#__PURE__*/_interopNamespace(i4$1);

    var defaultInputConfiguration = {
        componentType: 'input',
        formControl: new i1.FormControl(),
        type: { name: 'text', icon: 'article' },
        label: '',
        placeholder: '',
        isInputTypePassword: false,
        themeColor: 'primary',
        isRtl: false,
        autofocus: false,
        readonly: false,
        hint: '',
    };

    var defaultButtonConfiguration = {
        formControlName: new i1.FormControl(),
        componentType: 'button',
        type: { name: 'accept', icon: 'check_circle' },
        themeColor: 'primary',
        label: '',
        width: '180',
        isRtl: false,
        tailwindsClassForLabel: '',
        hasToolTip: false,
        tooltipText: '',
        tooltipPosition: 'left',
        tooltipHideDelay: 0,
        hasIcon: false,
        icon: '',
        localNavigationUrl: '',
        externalLink: '',
    };

    var ButtonConfigurationComponent = /** @class */ (function () {
        function ButtonConfigurationComponent(fb) {
            this.fb = fb;
            this.themeColors = ['primary', 'accent', 'warn'];
            this.componentConfiguration = new i0.EventEmitter();
            this.buttonTypes = [
                { name: 'accept', icon: 'check_circle' },
                { name: 'reject', icon: 'cancel' },
                { name: 'upload', icon: 'upload' },
                { name: 'download', icon: 'download' },
                { name: 'local Route', icon: 'alt_route' },
                { name: 'externalLink', icon: 'link' },
            ];
            this.form = this.fb.group({
                componentType: [''],
                formControlName: [null, [i1.Validators.required, i1.Validators.pattern(/^[a-zA-Z]*$/)]],
                type: ['', i1.Validators.required],
                width: ['', i1.Validators.required],
                themeColor: ['primary', i1.Validators.required],
                label: ['', i1.Validators.required],
                tooltipText: [''],
            });
        }
        ButtonConfigurationComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.form.get('type').valueChanges.subscribe(function (value) {
                value.name === 'download' || value.name === 'externalLink'
                    ? _this.form.addControl('downloadOrExternalNavigateLink', new i1.FormControl('', i1.Validators.required))
                    : !_this.form.get('downloadOrExternalNavigateLink') && _this.form.removeControl('downloadOrExternalNavigateLink');
            });
            this.setDataForEditMode();
        };
        ButtonConfigurationComponent.prototype.submitComponentConfigurationForm = function () {
            var data = this.form.value;
            data.formControlName = new i1.FormControl(this.form.value.formControlName);
            this.componentConfiguration.emit(data);
        };
        ButtonConfigurationComponent.prototype.setDataForEditMode = function () {
            var _this = this;
            var _a, _b, _c, _d, _e, _f;
            (_a = this.form.get('componentType')) === null || _a === void 0 ? void 0 : _a.setValue(this.buttonConfiguration.componentType);
            (_b = this.form.get('formControlName')) === null || _b === void 0 ? void 0 : _b.setValue(this.buttonConfiguration.formControlName.value);
            (_c = this.form.get('width')) === null || _c === void 0 ? void 0 : _c.setValue(this.buttonConfiguration.width);
            (_d = this.form.get('label')) === null || _d === void 0 ? void 0 : _d.setValue(this.buttonConfiguration.label);
            (_e = this.form.get('themeColor')) === null || _e === void 0 ? void 0 : _e.setValue(this.buttonConfiguration.themeColor);
            (_f = this.form.get('tooltipText')) === null || _f === void 0 ? void 0 : _f.setValue(this.buttonConfiguration.tooltipText);
            this.buttonTypes.map(function (buttonType) { var _a; return buttonType.name === _this.buttonConfiguration.type.name && ((_a = _this.form.get('type')) === null || _a === void 0 ? void 0 : _a.setValue(buttonType)); });
        };
        return ButtonConfigurationComponent;
    }());
    ButtonConfigurationComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationComponent, deps: [{ token: i1__namespace.FormBuilder }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ButtonConfigurationComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: ButtonConfigurationComponent, selector: "app-button-configuration", inputs: { buttonConfiguration: "buttonConfiguration" }, outputs: { componentConfiguration: "componentConfiguration" }, ngImport: i0__namespace, template: "<form (submit)=\"submitComponentConfigurationForm()\" [formGroup]=\"form\" class=\"ag-flex ag-flex-col ag-h-full\">\n    <div class=\"ag-h-5-6 ag-overflow-y-auto ag-flex ag-flex-col\">\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Form Control Name</mat-label>\n            <input matInput type=\"text\" formControlName=\"formControlName\" pattern=\"[a-zA-Z ]*\" />\n            <button *ngIf=\"form.get('formControlName')!.value\" matSuffix mat-icon-button (click)=\"form.get('formControlName')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n            <mat-error *ngIf=\"form.get('formControlName')!.hasError('pattern')\"> You should only use English letters for this field </mat-error>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Label</mat-label>\n            <input matInput type=\"text\" formControlName=\"label\" />\n            <button *ngIf=\"form.get('label')!.value\" matSuffix mat-icon-button (click)=\"form.get('label')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Tooltip</mat-label>\n            <input matInput type=\"text\" formControlName=\"tooltipText\" />\n            <button *ngIf=\"form.get('tooltipText')!.value\" matSuffix mat-icon-button (click)=\"form.get('tooltipText')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Button Type</mat-label>\n            <mat-select formControlName=\"type\">\n                <mat-select-trigger class=\"ag-flex\">\n                    <mat-icon fontSet=\"material-icons-outlined\" color=\"primary\">{{ form.get('type')!.value.icon }}</mat-icon>\n                    <span style=\"line-height: 24px\" class=\"ag-mx-4\">{{ form.get('type')!.value.name | titlecase }}</span>\n                </mat-select-trigger>\n                <mat-option *ngFor=\"let buttonType of buttonTypes\" [value]=\"buttonType\">\n                    <mat-icon fontSet=\"material-icons-outlined\" color=\"primary\">{{ buttonType.icon }}</mat-icon>\n                    <span>{{ buttonType.name | titlecase }}</span>\n                </mat-option>\n            </mat-select>\n        </mat-form-field>\n\n        <mat-form-field\n            appearance=\"outline\"\n            class=\"ag-mx-3\"\n            *ngIf=\"form.get('type')!.value.name === 'externalLink' || form.get('type')!.value.name === 'download'\"\n        >\n            <mat-label>Link</mat-label>\n            <input matInput type=\"text\" formControlName=\"downloadOrExternalNavigateLink\" />\n            <button *ngIf=\"form.get('tooltipText')!.value\" matSuffix mat-icon-button (click)=\"form.get('downloadOrExternalNavigateLink')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Button theme</mat-label>\n            <mat-select formControlName=\"themeColor\">\n                <mat-select-trigger class=\"ag-flex\">\n                    <mat-icon fontSet=\"material-icons-outlined\" [color]=\"form.get('themeColor')!.value\">circle</mat-icon>\n                    <span style=\"line-height: 24px\" class=\"ag-mx-4\">{{ form.get('themeColor')!.value | titlecase }}</span>\n                </mat-select-trigger>\n                <mat-option *ngFor=\"let themeColor of themeColors\" [value]=\"themeColor\">\n                    <mat-icon fontSet=\"material-icons-outlined\" [color]=\"themeColor\">circle</mat-icon>\n                    <span>{{ themeColor | titlecase }}</span>\n                </mat-option>\n            </mat-select>\n        </mat-form-field>\n    </div>\n\n    <button class=\"ag-w-3-5 ag-mx-auto ag-my-auto\" mat-flat-button color=\"primary\" type=\"submit\" [disabled]=\"form.invalid\">\n        <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-mx-2\">save</mat-icon>\n        <span>Save Component Settings</span>\n    </button>\n</form>\n", styles: [""], components: [{ type: i2__namespace.MatFormField, selector: "mat-form-field", inputs: ["color", "floatLabel", "appearance", "hideRequiredMarker", "hintLabel"], exportAs: ["matFormField"] }, { type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i5__namespace.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i6__namespace.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i1__namespace.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1__namespace.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1__namespace.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i2__namespace.MatLabel, selector: "mat-label" }, { type: i7__namespace.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["id", "disabled", "required", "type", "value", "readonly", "placeholder", "errorStateMatcher", "aria-describedby"], exportAs: ["matInput"] }, { type: i1__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1__namespace.FormControlName, selector: "[formControlName]", inputs: ["disabled", "formControlName", "ngModel"], outputs: ["ngModelChange"] }, { type: i1__namespace.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.MatSuffix, selector: "[matSuffix]" }, { type: i2__namespace.MatError, selector: "mat-error", inputs: ["id"] }, { type: i5__namespace.MatSelectTrigger, selector: "mat-select-trigger" }, { type: i8__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "titlecase": i8__namespace.TitleCasePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'app-button-configuration',
                        templateUrl: './button-configuration.component.html',
                        styleUrls: ['./button-configuration.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.FormBuilder }]; }, propDecorators: { componentConfiguration: [{
                    type: i0.Output
                }], buttonConfiguration: [{
                    type: i0.Input
                }] } });

    var InputConfigurationComponent = /** @class */ (function () {
        function InputConfigurationComponent(fb) {
            this.fb = fb;
            this.themeColors = ['primary', 'accent', 'warn'];
            this.componentConfiguration = new i0.EventEmitter();
            this.inputTypes = [
                { name: 'text', icon: 'article' },
                { name: 'email', icon: 'email' },
                { name: 'tel', icon: 'phone' },
                { name: 'url', icon: 'link' },
                { name: 'numeric', icon: 'pin' },
            ];
            this.form = this.fb.group({
                componentType: ['input'],
                formControl: ['', [i1.Validators.required, i1.Validators.pattern(/^[a-zA-Z]*$/)]],
                type: [null, i1.Validators.required],
                label: ['', i1.Validators.required],
                placeholder: [''],
                isInputTypePassword: [false, i1.Validators.required],
                themeColor: ['primary', i1.Validators.required],
                isRtl: [false, i1.Validators.required],
                hint: [''],
            });
        }
        InputConfigurationComponent.prototype.ngOnInit = function () {
            this.setFormValue();
        };
        InputConfigurationComponent.prototype.submitComponentConfigurationForm = function () {
            var data = this.form.value;
            data.formControl = new i1.FormControl(this.form.value.formControl);
            this.componentConfiguration.emit(data);
        };
        InputConfigurationComponent.prototype.setFormValue = function () {
            var _this = this;
            var _a, _b, _c, _d, _e, _f, _g, _h;
            (_a = this.form.get('componentType')) === null || _a === void 0 ? void 0 : _a.setValue(this.inputConfiguration.componentType);
            (_b = this.form.get('formControl')) === null || _b === void 0 ? void 0 : _b.setValue(this.inputConfiguration.formControl.value);
            (_c = this.form.get('label')) === null || _c === void 0 ? void 0 : _c.setValue(this.inputConfiguration.label);
            (_d = this.form.get('placeholder')) === null || _d === void 0 ? void 0 : _d.setValue(this.inputConfiguration.placeholder);
            (_e = this.form.get('isInputTypePassword')) === null || _e === void 0 ? void 0 : _e.setValue(this.inputConfiguration.isInputTypePassword);
            (_f = this.form.get('themeColor')) === null || _f === void 0 ? void 0 : _f.setValue(this.inputConfiguration.themeColor);
            (_g = this.form.get('isRtl')) === null || _g === void 0 ? void 0 : _g.setValue(this.inputConfiguration.isRtl);
            (_h = this.form.get('hint')) === null || _h === void 0 ? void 0 : _h.setValue(this.inputConfiguration.hint);
            this.inputTypes.map(function (inputType) { var _a; return inputType.name === _this.inputConfiguration.type.name && ((_a = _this.form.get('type')) === null || _a === void 0 ? void 0 : _a.setValue(inputType)); });
        };
        return InputConfigurationComponent;
    }());
    InputConfigurationComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationComponent, deps: [{ token: i1__namespace.FormBuilder }], target: i0__namespace.ɵɵFactoryTarget.Component });
    InputConfigurationComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: InputConfigurationComponent, selector: "app-input-configuration", inputs: { inputConfiguration: "inputConfiguration" }, outputs: { componentConfiguration: "componentConfiguration" }, ngImport: i0__namespace, template: "<form (submit)=\"submitComponentConfigurationForm()\" [formGroup]=\"form\" class=\"ag-flex ag-flex-col ag-h-full\">\n    <div class=\"ag-h-5-6 ag-overflow-y-auto ag-flex ag-flex-col\">\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Form Control Name</mat-label>\n            <input matInput type=\"text\" formControlName=\"formControl\" pattern=\"[a-zA-Z ]*\" />\n            <button *ngIf=\"form.get('formControl')!.value\" matSuffix mat-icon-button (click)=\"form.get('formControl')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n            <mat-error *ngIf=\"form.get('formControl')!.hasError('pattern')\"> You should only use English letters for this field </mat-error>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Input Type</mat-label>\n            <mat-select formControlName=\"type\">\n                <mat-select-trigger class=\"ag-flex\">\n                    <mat-icon fontSet=\"material-icons-outlined\" color=\"primary\">{{ form.get('type')!.value.icon }}</mat-icon>\n                    <span style=\"line-height: 24px\" class=\"ag-mx-4\">{{ form.get('type')!.value.name | titlecase }}</span>\n                </mat-select-trigger>\n                <mat-option *ngFor=\"let inputType of inputTypes\" [value]=\"inputType\">\n                    <mat-icon fontSet=\"material-icons-outlined\" color=\"primary\">{{ inputType.icon }}</mat-icon>\n                    <span>{{ inputType.name | titlecase }}</span>\n                </mat-option>\n            </mat-select>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Label</mat-label>\n            <input matInput type=\"text\" formControlName=\"label\" />\n            <button *ngIf=\"form.get('label')!.value\" matSuffix mat-icon-button (click)=\"form.get('label')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Placeholder</mat-label>\n            <input matInput type=\"text\" formControlName=\"placeholder\" />\n            <button *ngIf=\"form.get('placeholder')!.value\" matSuffix mat-icon-button (click)=\"form.get('placeholder')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Hint</mat-label>\n            <input matInput type=\"text\" formControlName=\"hint\" />\n            <button *ngIf=\"form.get('hint')!.value\" matSuffix mat-icon-button (click)=\"form.get('hint')?.setValue('')\">\n                <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n            </button>\n        </mat-form-field>\n\n        <mat-form-field appearance=\"outline\" class=\"ag-mx-3\">\n            <mat-label>Input theme</mat-label>\n            <mat-select formControlName=\"themeColor\">\n                <mat-select-trigger class=\"ag-flex\">\n                    <mat-icon fontSet=\"material-icons-outlined\" [color]=\"form.get('themeColor')!.value\">circle</mat-icon>\n                    <span style=\"line-height: 24px\" class=\"ag-mx-4\">{{ form.get('themeColor')!.value | titlecase }}</span>\n                </mat-select-trigger>\n                <mat-option *ngFor=\"let themeColor of themeColors\" [value]=\"themeColor\">\n                    <mat-icon fontSet=\"material-icons-outlined\" [color]=\"themeColor\">circle</mat-icon>\n                    <span>{{ themeColor | titlecase }}</span>\n                </mat-option>\n            </mat-select>\n        </mat-form-field>\n\n        <div class=\"ag-mx-3 ag-mb-3-5\">\n            <mat-slide-toggle class=\"ag-my-2\" formControlName=\"isInputTypePassword\" color=\"primary\"> Is your input component's type password? </mat-slide-toggle>\n            <mat-slide-toggle class=\"ag-my-2\" formControlName=\"isRtl\" color=\"primary\"> Is your input component's alignment RTL? </mat-slide-toggle>\n        </div>\n    </div>\n\n    <button class=\"ag-w-3-5 ag-mx-auto ag-my-auto\" mat-flat-button color=\"primary\" type=\"submit\" [disabled]=\"form.invalid\">\n        <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-mx-2\">save</mat-icon>\n        <span>Save Component Settings</span>\n    </button>\n</form>\n", styles: [""], components: [{ type: i2__namespace.MatFormField, selector: "mat-form-field", inputs: ["color", "floatLabel", "appearance", "hideRequiredMarker", "hintLabel"], exportAs: ["matFormField"] }, { type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i5__namespace.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i6__namespace.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i7__namespace$1.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex", "name", "id", "labelPosition", "aria-label", "aria-labelledby", "required", "checked", "aria-describedby"], outputs: ["change", "toggleChange"], exportAs: ["matSlideToggle"] }], directives: [{ type: i1__namespace.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1__namespace.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1__namespace.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i2__namespace.MatLabel, selector: "mat-label" }, { type: i7__namespace.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["id", "disabled", "required", "type", "value", "readonly", "placeholder", "errorStateMatcher", "aria-describedby"], exportAs: ["matInput"] }, { type: i1__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1__namespace.FormControlName, selector: "[formControlName]", inputs: ["disabled", "formControlName", "ngModel"], outputs: ["ngModelChange"] }, { type: i1__namespace.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.MatSuffix, selector: "[matSuffix]" }, { type: i2__namespace.MatError, selector: "mat-error", inputs: ["id"] }, { type: i5__namespace.MatSelectTrigger, selector: "mat-select-trigger" }, { type: i8__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "titlecase": i8__namespace.TitleCasePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'app-input-configuration',
                        templateUrl: './input-configuration.component.html',
                        styleUrls: ['./input-configuration.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.FormBuilder }]; }, propDecorators: { componentConfiguration: [{
                    type: i0.Output
                }], inputConfiguration: [{
                    type: i0.Input
                }] } });

    var SettingModalComponent = /** @class */ (function () {
        function SettingModalComponent(matDialog, data) {
            this.matDialog = matDialog;
            this.data = data;
            this.columns = [];
            this.sectionInfo = {
                sectionIndex: this.data.sectionIndex,
                sectionColumns: [],
            };
            if (this.data.sectionInfo.columnsCount > 0)
                this.setDataForEditMode();
        }
        SettingModalComponent.prototype.addColumn = function (componentType) {
            this.columns.push({
                columnId: 1,
                columnComponentType: 'input',
                columnSetting: componentType === 'input' ? defaultInputConfiguration : defaultButtonConfiguration,
            });
        };
        SettingModalComponent.prototype.removeColumn = function (column) {
            var columnIndex = this.columns.indexOf(column);
            this.columns.splice(columnIndex, 1);
            this.sectionInfo.sectionColumns.splice(columnIndex, 1);
        };
        SettingModalComponent.prototype.checkColumnsCountForLessThanThree = function () {
            return this.columns.length < 3;
        };
        SettingModalComponent.prototype.discardSectionSettings = function () {
            this.matDialog.close(false);
        };
        SettingModalComponent.prototype.saveSectionSettings = function () {
            this.matDialog.close(this.sectionInfo);
        };
        SettingModalComponent.prototype.getComponentConfigurationEvent = function (event, componentType, columnIndex) {
            this.sectionInfo.sectionColumns[columnIndex] = { index: columnIndex, componentType: componentType, componentInfo: event };
        };
        SettingModalComponent.prototype.setDataForEditMode = function () {
            var _this = this;
            this.columns = [];
            this.data.sectionInfo.columnInfo.map(function (item) {
                _this.columns.push({ columnId: item.index, columnComponentType: item.componentType, columnSetting: item.componentInfo });
                _this.sectionInfo.sectionColumns.push({ index: item.index, componentInfo: item.componentInfo, componentType: item.componentType });
            });
        };
        SettingModalComponent.prototype.returnInputFormConfiguration = function (sectionColumn) {
            return this.columns.length > 0 ? sectionColumn.columnSetting : defaultInputConfiguration;
        };
        SettingModalComponent.prototype.returnButtonFormConfiguration = function (sectionColumn) {
            return this.columns.length > 0 ? sectionColumn.columnSetting : defaultButtonConfiguration;
        };
        SettingModalComponent.prototype.onComponentTypeValueChange = function (column, selectedColumnComponentType) {
            var columnIndex = this.columns.indexOf(column);
            this.columns[columnIndex] = {
                columnSetting: selectedColumnComponentType === 'button' ? defaultButtonConfiguration : defaultInputConfiguration,
                columnId: this.columns[columnIndex].columnId,
                columnComponentType: selectedColumnComponentType,
            };
        };
        return SettingModalComponent;
    }());
    SettingModalComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalComponent, deps: [{ token: i1__namespace$1.MatDialogRef }, { token: i1$1.MAT_DIALOG_DATA }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SettingModalComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: SettingModalComponent, selector: "app-setting-modal", ngImport: i0__namespace, template: "<div class=\"ag-flex ag-flex-col ag-justify-between ag-h-full\">\n    <div class=\"ag-flex ag-justify-center ag-items-center ag-grid ag-grid-cols-3\">\n        <mat-card *ngFor=\"let column of columns; let index = index\" class=\"ag-bg-gray-100 ag-mx-2 ag-flex ag-flex-col ag-h-full\">\n            <div class=\"ag-max-w-full ag-text-center ag-w-full ag-mx-0 ag-px-3-5\">\n                <mat-card-title class=\"ag-text-base ag-w-full ag-flex ag-justify-center ag-items-baseline\">\n                    <mat-form-field appearance=\"outline\" class=\"ag-w-full ag-p-0 ag-m-0\">\n                        <mat-label>Select your component type</mat-label>\n                        <mat-select [value]=\"column.columnComponentType ?? 'input'\" #matSelect (valueChange)=\"onComponentTypeValueChange(column, $event)\">\n                            <mat-option value=\"input\">Input Component</mat-option>\n                            <mat-option value=\"button\">Button Component</mat-option>\n                        </mat-select>\n                    </mat-form-field>\n\n                    <button class=\"ag-ml-4\" mat-icon-button color=\"warn\" matTooltip=\"Remove Column\" matTooltipPosition=\"below\" (click)=\"removeColumn(column)\">\n                        <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-4xl\" inline>highlight_off</mat-icon>\n                    </button>\n                </mat-card-title>\n\n                <mat-card-subtitle>\n                    <p class=\"ag-text-center ag-text-lg ag-font-black\">{{ matSelect.value === 'input' ? 'Input ' : 'Button ' }}Component Configuration</p>\n                </mat-card-subtitle>\n            </div>\n\n            <mat-card-content class=\"ag-overflow-y-auto ag-h-5-6\">\n                <!--  Button Component  -->\n\n                <app-button-configuration\n                    *ngIf=\"matSelect.value === 'button'\"\n                    [buttonConfiguration]=\"returnButtonFormConfiguration(column)\"\n                    (componentConfiguration)=\"getComponentConfigurationEvent($event, 'button', index)\"\n                ></app-button-configuration>\n\n                <!--  Input Component  -->\n                <app-input-configuration\n                    *ngIf=\"matSelect.value === 'input'\"\n                    [inputConfiguration]=\"returnInputFormConfiguration(column)\"\n                    (componentConfiguration)=\"getComponentConfigurationEvent($event, 'input', index)\"\n                ></app-input-configuration>\n            </mat-card-content>\n        </mat-card>\n\n        <button mat-button [disableRipple]=\"true\" (click)=\"addColumn('input')\" matTooltip=\"Add new Column\" matTooltipPosition=\"below\" class=\"ag-p-0\">\n            <mat-card\n                *ngIf=\"checkColumnsCountForLessThanThree()\"\n                class=\"ag-flex ag-flex-col ag-justify-center ag-items-center ag-bg-gray-100 ag-mx-5 ag-h-5-6 empty-state-section ag-m-0\"\n            >\n                <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-blue-600 ag-text-7xl ag-flex ag-justify-center ag-items-center\"\n                    >add_circle\n                </mat-icon>\n            </mat-card>\n        </button>\n    </div>\n\n    <div class=\"ag-flex ag-justify-evenly ag-items-end\">\n        <button mat-flat-button color=\"warn\" matTooltip=\"Close Section Settings\" matTooltipPosition=\"below\" (click)=\"discardSectionSettings()\">\n            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-3xl\" inline>close</mat-icon>\n            <span>Close Section Settings</span>\n        </button>\n\n        <button mat-flat-button color=\"primary\" matTooltip=\"Close Section Settings\" matTooltipPosition=\"below\" (click)=\"saveSectionSettings()\">\n            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-3xl\" inline>save</mat-icon>\n            <span>Save Section Settings</span>\n        </button>\n    </div>\n</div>\n", styles: ["mat-card{min-height:680px;max-height:680px}.empty-state-section{border:3px dashed #3f51b5;opacity:.8;background:#e1edfc repeating-linear-gradient(45deg,#e7f4ff,#e7f4ff 5px,#e1edfc 5px,#e1edfc 25px)}\n"], components: [{ type: i3__namespace$1.MatCard, selector: "mat-card", exportAs: ["matCard"] }, { type: i2__namespace.MatFormField, selector: "mat-form-field", inputs: ["color", "floatLabel", "appearance", "hideRequiredMarker", "hintLabel"], exportAs: ["matFormField"] }, { type: i5__namespace.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i6__namespace.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: ButtonConfigurationComponent, selector: "app-button-configuration", inputs: ["buttonConfiguration"], outputs: ["componentConfiguration"] }, { type: InputConfigurationComponent, selector: "app-input-configuration", inputs: ["inputConfiguration"], outputs: ["componentConfiguration"] }], directives: [{ type: i8__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i3__namespace$1.MatCardTitle, selector: "mat-card-title, [mat-card-title], [matCardTitle]" }, { type: i2__namespace.MatLabel, selector: "mat-label" }, { type: i11__namespace.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i3__namespace$1.MatCardSubtitle, selector: "mat-card-subtitle, [mat-card-subtitle], [matCardSubtitle]" }, { type: i3__namespace$1.MatCardContent, selector: "mat-card-content, [mat-card-content], [matCardContent]" }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'app-setting-modal',
                        templateUrl: './setting-modal.component.html',
                        styleUrls: ['./setting-modal.component.scss'],
                    }]
            }], ctorParameters: function () {
            return [{ type: i1__namespace$1.MatDialogRef }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [i1$1.MAT_DIALOG_DATA]
                        }] }];
        } });

    var ButtonComponent = /** @class */ (function () {
        function ButtonComponent(router) {
            this.router = router;
            this.disableButton = false;
        }
        ButtonComponent.prototype.handleClick = function () {
            if (!this.buttonConfiguration.localNavigationUrl && this.buttonConfiguration.externalLink) {
                window.location.href = this.buttonConfiguration.externalLink;
            }
            else if (this.buttonConfiguration.localNavigationUrl && !this.buttonConfiguration.externalLink) {
                this.router.navigate(["" + this.buttonConfiguration.localNavigationUrl]).finally();
            }
        };
        return ButtonComponent;
    }());
    ButtonComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonComponent, deps: [{ token: i1__namespace$2.Router }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ButtonComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: ButtonComponent, selector: "app-button", inputs: { disableButton: "disableButton", buttonConfiguration: "buttonConfiguration" }, ngImport: i0__namespace, template: "<a (click)=\"handleClick()\" [dir]=\"buttonConfiguration.isRtl ? 'rtl' : 'ltr'\">\n    <button\n        mat-flat-button\n        [style.width.px]=\"buttonConfiguration.width\"\n        [routerLink]=\"buttonConfiguration.localNavigationUrl\"\n        [matTooltip]=\"buttonConfiguration.tooltipText ?? ''\"\n        [matTooltipDisabled]=\"!buttonConfiguration.hasToolTip\"\n        [matTooltipPosition]=\"buttonConfiguration.tooltipPosition ?? 'below'\"\n        [matTooltipHideDelay]=\"buttonConfiguration.tooltipHideDelay ?? 0\"\n        [color]=\"buttonConfiguration.themeColor\"\n        [disabled]=\"disableButton\"\n    >\n        <span [className]=\"buttonConfiguration.tailwindsClassForLabel\">{{ buttonConfiguration.label }}</span>\n        <mat-icon fontSet=\"material-icons-outlined\" *ngIf=\"buttonConfiguration.hasIcon\">{{ buttonConfiguration.icon }}</mat-icon>\n    </button>\n</a>\n", styles: [""], components: [{ type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i4__namespace$1.Dir, selector: "[dir]", inputs: ["dir"], outputs: ["dirChange"], exportAs: ["dir"] }, { type: i1__namespace$2.RouterLink, selector: ":not(a):not(area)[routerLink]", inputs: ["routerLink", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo"] }, { type: i11__namespace.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'app-button',
                        templateUrl: './button.component.html',
                        styleUrls: ['./button.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace$2.Router }]; }, propDecorators: { disableButton: [{
                    type: i0.Input
                }], buttonConfiguration: [{
                    type: i0.Input
                }] } });

    var InputComponent = /** @class */ (function () {
        function InputComponent() {
            this.hideInputTextForPasswordInputs = false;
            this.readonlyForDemo = false;
            this.inputFormConfiguration = {
                componentType: 'input',
                formControl: new i1.FormControl(),
                type: { name: 'text', icon: 'article' },
                placeholder: 'placeholder',
                label: 'test',
                isInputTypePassword: true,
                themeColor: 'primary',
                isRtl: false,
                autofocus: false,
                readonly: false,
                errorMessages: [{ errorName: 'email', errorMessage: 'hello' }],
                hint: 'hint',
            };
        }
        InputComponent.prototype.ngOnChanges = function () {
            if (!this.FC)
                throw new Error('FC Input is required');
            if (this.inputFormConfiguration.isInputTypePassword)
                this.hideInputTextForPasswordInputs = true;
        };
        Object.defineProperty(InputComponent.prototype, "FC", {
            get: function () {
                return this.inputFormConfiguration.formControl;
            },
            enumerable: false,
            configurable: true
        });
        return InputComponent;
    }());
    InputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    InputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: InputComponent, selector: "app-input", inputs: { readonlyForDemo: "readonlyForDemo", inputFormConfiguration: "inputFormConfiguration" }, usesOnChanges: true, ngImport: i0__namespace, template: "<mat-form-field appearance=\"outline\" [color]=\"inputFormConfiguration.themeColor\">\n    <mat-label>{{ inputFormConfiguration.label }}</mat-label>\n    <input\n        matInput\n        [attr.placeholder]=\"inputFormConfiguration.placeholder\"\n        [formControl]=\"FC\"\n        [type]=\"hideInputTextForPasswordInputs ? 'password' : inputFormConfiguration.type.name\"\n        [class.text-ltr]=\"inputFormConfiguration.isRtl\"\n        [attr.type]=\"inputFormConfiguration.type.name === 'numeric' ? 'number' : inputFormConfiguration.type.name\"\n        [attr.inputmode]=\"inputFormConfiguration.type\"\n        [readonly]=\"inputFormConfiguration.readonly || readonlyForDemo\"\n        [autofocus]=\"inputFormConfiguration.autofocus\"\n    />\n    <button\n        *ngIf=\"inputFormConfiguration.isInputTypePassword\"\n        type=\"button\"\n        mat-icon-button\n        matSuffix\n        (click)=\"hideInputTextForPasswordInputs = !hideInputTextForPasswordInputs\"\n    >\n        <mat-icon fontSet=\"material-icons-outlined\">{{ hideInputTextForPasswordInputs ? 'visibility_off' : 'remove_red_eye' }}</mat-icon>\n    </button>\n    <mat-hint *ngIf=\"inputFormConfiguration.hint\">{{ inputFormConfiguration.hint }}</mat-hint>\n\n    <!--    <mat-error>-->\n    <!--        <ng-container *ngFor=\"let errorMessage of inputFormConfiguration.errorMessages; let last = last\">-->\n    <!--            <span class=\"app-input-mat-error\">{{ errorMessage.errorMessage }}</span>-->\n    <!--            <ng-container *ngIf=\"FC && FC.hasError(errorMessage.errorName) && (FC.dirty || FC.touched)\">-->\n    <!--                <span>{{ errorMessage.errorMessage }}</span>-->\n    <!--                <span *ngIf=\"!last\" class=\"app-input-mat-error-sep\"></span>-->\n    <!--            </ng-container>-->\n    <!--        </ng-container>-->\n    <!--    </mat-error>-->\n</mat-form-field>\n", styles: ["input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=number]{-moz-appearance:textfield}\n"], components: [{ type: i2__namespace.MatFormField, selector: "mat-form-field", inputs: ["color", "floatLabel", "appearance", "hideRequiredMarker", "hintLabel"], exportAs: ["matFormField"] }, { type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i2__namespace.MatLabel, selector: "mat-label" }, { type: i7__namespace.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["id", "disabled", "required", "type", "value", "readonly", "placeholder", "errorStateMatcher", "aria-describedby"], exportAs: ["matInput"] }, { type: i1__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1__namespace.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.MatSuffix, selector: "[matSuffix]" }, { type: i2__namespace.MatHint, selector: "mat-hint", inputs: ["align", "id"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'app-input',
                        templateUrl: './input.component.html',
                        styleUrls: ['./input.component.scss'],
                    }]
            }], propDecorators: { readonlyForDemo: [{
                    type: i0.Input
                }], inputFormConfiguration: [{
                    type: i0.Input
                }] } });

    var WrapperComponent = /** @class */ (function () {
        function WrapperComponent(dialog, fb) {
            this.dialog = dialog;
            this.fb = fb;
            this.emittedFormInfo = new i0.EventEmitter();
            this.sections = [];
            this.form = this.fb.group({
                name: [null, [i1.Validators.required, i1.Validators.pattern(/^[a-zA-Z]*$/)]],
            });
        }
        WrapperComponent.prototype.clearForm = function () {
            this.sections = [];
            this.form.reset();
        };
        WrapperComponent.prototype.addSection = function () {
            this.sections.push({ columnsCount: 0 });
        };
        WrapperComponent.prototype.removeSection = function (section) {
            var sectionIndex = this.sections.indexOf(section);
            this.sections.splice(sectionIndex, 1);
        };
        WrapperComponent.prototype.openSettingDialog = function (sectionIndex, sectionInfo) {
            var _this = this;
            this.dialog
                .open(SettingModalComponent, { data: { sectionIndex: sectionIndex, sectionInfo: sectionInfo }, height: '800px', width: '1600px' })
                .afterClosed()
                .subscribe(function (sectionInfo) {
                sectionInfo && _this.createSectionPreview(sectionInfo);
            });
        };
        WrapperComponent.prototype.submitForm = function () {
            var data = Object.assign(Object.assign({}, this.form.value), { sections: this.sections });
            this.emittedFormInfo.emit(data);
        };
        WrapperComponent.prototype.isSubmitButtonDisable = function () {
            return this.form.valid && !!this.sections.length;
        };
        WrapperComponent.prototype.createSectionPreview = function (sectionInfo) {
            this.sections[sectionInfo.sectionIndex] = {
                columnInfo: sectionInfo.sectionColumns,
                columnsCount: sectionInfo.sectionColumns.length,
            };
        };
        return WrapperComponent;
    }());
    WrapperComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperComponent, deps: [{ token: i1__namespace$1.MatDialog }, { token: i1__namespace.FormBuilder }], target: i0__namespace.ɵɵFactoryTarget.Component });
    WrapperComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: WrapperComponent, selector: "lib-wrapper", outputs: { emittedFormInfo: "emittedFormInfo" }, ngImport: i0__namespace, template: "<mat-card class=\"ag-flex ag-flex-col ag-h-full ag-px-0 ag-pt-0 ag-bg-gray-100\">\n    <mat-card-header class=\"ag-flex ag-flex-col ag-text-center ag-m-0 ag-w-full ag-bg-blue-300 ag-mb-10\">\n        <mat-card-title class=\"ag-text-base ag-flex ag-justify-around ag-items-baseline ag-pt-5\">\n            <a href=\"https://github.com/hossein13m/angular-form-builder\" target=\"_blank\">\n                <h1 class=\"ag-flex ag-items-center\">\n                    <span class=\"ag-mx-2\"> AG FormBuilder </span>\n                    <mat-icon fontSet=\"material-icons-outlined\"> dashboard </mat-icon>\n                </h1>\n            </a>\n\n            <form (submit)=\"submitForm()\" id=\"form\" [formGroup]=\"form\">\n                <mat-form-field appearance=\"outline\" class=\"ag-mx-3 ag-flex ag-justify-center\">\n                    <mat-label>\n                        <span>Form Name</span>\n                    </mat-label>\n                    <input matInput type=\"text\" formControlName=\"name\" pattern=\"[a-zA-Z ]*\" />\n                    <button *ngIf=\"form.get('name')!.value\" matSuffix mat-icon-button (click)=\"form.get('name')?.setValue(null)\">\n                        <mat-icon fontSet=\"material-icons-outlined\">close</mat-icon>\n                    </button>\n                    <mat-hint *ngIf=\"!form.get('name')!.hasError('pattern')\" class=\"ag-flex\">\n                        <span>Can't be changed in future</span>\n                    </mat-hint>\n                    <mat-error *ngIf=\"form.get('name')!.hasError('pattern')\" class=\"ag-flex\">\n                        <span>Only English letters are accepted</span>\n                    </mat-error>\n                </mat-form-field>\n            </form>\n        </mat-card-title>\n\n        <mat-card-subtitle>\n            <hr class=\"ag-w-full ag-my-3\" />\n            <h3>Create your form by creating sections and then configure those section's column. In each Section you can set up to 3 components</h3>\n        </mat-card-subtitle>\n    </mat-card-header>\n\n    <mat-card-content class=\"ag-overflow-y-auto ag-h-5-6 ag-mt-10\">\n        <mat-grid-list cols=\"1\" rowHeight=\"150px\" gutterSize=\"30px\" class=\"ag-mx-5\">\n            <!-- section -->\n            <mat-grid-tile *ngFor=\"let section of sections; let index = index\" class=\"ag-w-full\">\n                <div class=\"ag-flex ag-flex-col ag-w-full ag-h-full\">\n                    <div class=\"ag-flex ag-justify-around ag-w-full ag-text-center ag-h-full ag-items-center\">\n                        <div *ngIf=\"sections[index].columnsCount === 0\" class=\"ag-flex ag-items-center\">\n                            <h1 class=\"ag-mb-0\">Click on setting button to add components into this section</h1>\n                        </div>\n                        <div\n                            class=\"ag-h-full ag-flex ag-justify-center ag-items-center ag-w-full component-group\"\n                            *ngFor=\"let column of sections[index].columnInfo\"\n                        >\n                            <!--  button component  -->\n                            <app-button *ngIf=\"column.componentInfo.componentType === 'button'\" [buttonConfiguration]=\"column.componentInfo\"> </app-button>\n                            <!--  input component  -->\n                            <app-input\n                                *ngIf=\"column.componentInfo.componentType === 'input'\"\n                                [readonlyForDemo]=\"true\"\n                                [inputFormConfiguration]=\"column.componentInfo\"\n                            ></app-input>\n                        </div>\n                    </div>\n\n                    <div class=\"ag-flex ag-flex-row ag-justify-around ag-mt-auto section-button\">\n                        <button\n                            mat-button\n                            class=\"ag-w-full p-1 ag-bg-blue-100 ag-hover-bg-blue-200\"\n                            matTooltip=\"Section Setting\"\n                            matTooltipPosition=\"below\"\n                            (click)=\"openSettingDialog(index, section)\"\n                        >\n                            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-blue-600\">settings</mat-icon>\n                        </button>\n                        <button\n                            mat-button\n                            class=\"ag-w-full p-1 ag-bg-blue-100 ag-hover-bg-blue-200\"\n                            matTooltip=\"Remove Section\"\n                            matTooltipPosition=\"below\"\n                            (click)=\"removeSection(section)\"\n                        >\n                            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-blue-600\">remove_circle</mat-icon>\n                        </button>\n                    </div>\n                </div>\n            </mat-grid-tile>\n\n            <!-- section empty state  -->\n            <button (click)=\"addSection()\">\n                <mat-grid-tile class=\"empty-state-section\" matTooltip=\"Add Section\" matTooltipPosition=\"below\">\n                    <mat-icon fontSet=\"material-icons-outlined\" class=\"add-section-button ag-text-blue-600\">add_circle </mat-icon>\n                </mat-grid-tile>\n            </button>\n        </mat-grid-list>\n    </mat-card-content>\n\n    <mat-card-actions class=\"ag-flex ag-justify-around\">\n        <button mat-flat-button color=\"warn\" (click)=\"clearForm()\">\n            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-2xl\" inline>restart_alt</mat-icon>\n            <span>Reset Form</span>\n        </button>\n\n        <button mat-flat-button color=\"primary\" class=\"ag-bg-light-blue-300\" form=\"form\" type=\"submit\" [disabled]=\"!isSubmitButtonDisable()\">\n            <mat-icon fontSet=\"material-icons-outlined\" class=\"ag-text-2xl\" inline>save</mat-icon>\n            <span>Save Form</span>\n        </button>\n    </mat-card-actions>\n</mat-card>\n", styles: ["mat-card{display:flex}mat-card mat-card-content mat-grid-list{min-width:1400px;padding:20px}mat-card mat-card-content mat-grid-list .empty-state-section{border:3px dashed #3f51b5;opacity:.8;background:#e1edfc repeating-linear-gradient(45deg,#e7f4ff,#e7f4ff 5px,#e1edfc 5px,#e1edfc 25px);cursor:pointer}mat-card mat-card-content mat-grid-list .component-group:nth-of-type(2n){border-left:4px solid #b9b9b9}mat-card mat-card-content mat-grid-list .component-group:nth-of-type(2n + 3){border-left:4px solid #b9b9b9}mat-card mat-card-content mat-grid-list mat-grid-tile{border-radius:10px;background:#ecf1f5}mat-card mat-card-content mat-grid-list mat-grid-tile .add-section-button{font-size:70px;display:flex;justify-content:center;align-items:center}mat-card mat-card-actions{display:flex}\n"], components: [{ type: i3__namespace$1.MatCard, selector: "mat-card", exportAs: ["matCard"] }, { type: i3__namespace$1.MatCardHeader, selector: "mat-card-header" }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i2__namespace.MatFormField, selector: "mat-form-field", inputs: ["color", "floatLabel", "appearance", "hideRequiredMarker", "hintLabel"], exportAs: ["matFormField"] }, { type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i7__namespace$2.MatGridList, selector: "mat-grid-list", inputs: ["cols", "gutterSize", "rowHeight"], exportAs: ["matGridList"] }, { type: i7__namespace$2.MatGridTile, selector: "mat-grid-tile", inputs: ["rowspan", "colspan"], exportAs: ["matGridTile"] }, { type: ButtonComponent, selector: "app-button", inputs: ["disableButton", "buttonConfiguration"] }, { type: InputComponent, selector: "app-input", inputs: ["readonlyForDemo", "inputFormConfiguration"] }], directives: [{ type: i3__namespace$1.MatCardTitle, selector: "mat-card-title, [mat-card-title], [matCardTitle]" }, { type: i1__namespace.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1__namespace.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1__namespace.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i2__namespace.MatLabel, selector: "mat-label" }, { type: i7__namespace.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["id", "disabled", "required", "type", "value", "readonly", "placeholder", "errorStateMatcher", "aria-describedby"], exportAs: ["matInput"] }, { type: i1__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1__namespace.FormControlName, selector: "[formControlName]", inputs: ["disabled", "formControlName", "ngModel"], outputs: ["ngModelChange"] }, { type: i1__namespace.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { type: i8__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.MatSuffix, selector: "[matSuffix]" }, { type: i2__namespace.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i2__namespace.MatError, selector: "mat-error", inputs: ["id"] }, { type: i3__namespace$1.MatCardSubtitle, selector: "mat-card-subtitle, [mat-card-subtitle], [matCardSubtitle]" }, { type: i3__namespace$1.MatCardContent, selector: "mat-card-content, [mat-card-content], [matCardContent]" }, { type: i8__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i11__namespace.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i3__namespace$1.MatCardActions, selector: "mat-card-actions", inputs: ["align"], exportAs: ["matCardActions"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-wrapper',
                        templateUrl: './wrapper.component.html',
                        styleUrls: ['./wrapper.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace$1.MatDialog }, { type: i1__namespace.FormBuilder }]; }, propDecorators: { emittedFormInfo: [{
                    type: i0.Output
                }] } });

    var AgFormBuilderComponent = /** @class */ (function () {
        function AgFormBuilderComponent() {
            this.emittedForm = new i0.EventEmitter();
        }
        AgFormBuilderComponent.prototype.handleFormInfo = function (event) {
            this.emittedForm.emit(event);
        };
        return AgFormBuilderComponent;
    }());
    AgFormBuilderComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    AgFormBuilderComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: AgFormBuilderComponent, selector: "ag-form-builder", outputs: { emittedForm: "emittedForm" }, ngImport: i0__namespace, template: "<lib-wrapper (emittedFormInfo)='handleFormInfo($event)'></lib-wrapper>\n", styles: ["a,button{outline:none!important;text-decoration:none!important;color:unset}*{box-sizing:border-box}html{height:100%;min-height:100%;font-family:sans-serif;-webkit-text-size-adjust:100%;-ms-text-size-adjust:100%}body{margin:0;height:100%;min-height:100%;word-break:break-word}::-webkit-scrollbar{width:10px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}.mat-tooltip{max-width:150px!important;background-color:#3c4b64!important;text-align:center!important;font-size:16px!important}.ag-flex{display:flex!important}.ag-flex-col{flex-direction:column!important}.ag-justify-around{justify-content:space-around!important}.ag-justify-between{justify-content:space-between!important}.ag-justify-center{justify-content:center!important}.ag-justify-evenly{justify-content:space-evenly}.ag-items-baseline{align-items:baseline!important}.ag-items-center{align-items:center!important}.ag-items-end{align-items:end!important}.ag-w-full{width:100%!important}.ag-w-3-5{width:60%!important}.ag-w-5-6{width:83.333333%!important}.ag-text-base{font-size:1rem!important;line-height:1.5rem!important}.ag-text-center{text-align:center!important}.ag-h-full{height:100%!important}.ag-h-5-6{height:83.333333%!important}.ag-bg-gray-100{--tw-bg-opacity: 1;background-color:rgba(243,244,246,var(--tw-bg-opacity))}.ag-bg-blue-300{--tw-bg-opacity: 1;background-color:rgba(147,197,253,var(--tw-bg-opacity))}.ag-bg-blue-200{--tw-bg-opacity: 1;background-color:rgba(191,219,254,var(--tw-bg-opacity))}.ag-bg-blue-100{--tw-bg-opacity: 1;background-color:rgba(219,234,254,var(--tw-bg-opacity))}.ag-bg-light-blue-300{--tw-bg-opacity: 1;background-color:rgba(147,197,253,var(--tw-bg-opacity))}.ag-hover-bg-blue-200:hover{--tw-bg-opacity: 1;background-color:rgba(191,219,254,var(--tw-bg-opacity))}.ag-overflow-y-auto{overflow-y:auto!important}.ag-text-blue-600{--tw-text-opacity: 1 !important;color:rgba(37,99,235,var(--tw-text-opacity))!important}.ag-text-2xl{font-size:1.5rem!important;line-height:2rem!important}.ag-grid{display:grid!important}.ag-grid-cols-3{grid-template-columns:repeat(3,minmax(0,1fr))!important}.ag-max-w-full{max-width:100%!important}.ag-text-4xl{font-size:2.25rem!important;line-height:2.5rem!important}.ag-font-black{font-weight:900!important}.ag-text-lg{font-size:1.125rem!important;line-height:1.75rem!important}.ag-text-7xl{font-size:4.5rem!important;line-height:1!important}.ag-text-3xl{font-size:1.875rem!important;line-height:2.25rem!important}.ag-mx-0{margin-left:0!important;margin-right:0!important}.ag-mx-2{margin-left:.5rem!important;margin-right:.5rem!important}.ag-mx-3{margin-left:.75rem!important;margin-right:.75rem!important}.ag-mx-4{margin-left:1rem!important;margin-right:1rem!important}.ag-mx-5{margin-left:1.25rem!important;margin-right:1.25rem!important}.ag-mx-auto{margin-left:auto!important;margin-right:auto!important}.ag-mb-0{margin-bottom:0!important}.ag-mb-3-5{margin-bottom:.875rem!important}.ag-mb-10{margin-bottom:-2.5rem!important}.ag-mt-auto{margin-top:auto!important}.ag-ml-4{margin-left:1rem!important}.ag-my-2{margin-top:.5rem!important;margin-bottom:.5rem!important}.ag-my-3{margin-top:.75rem!important;margin-bottom:.75rem!important}.ag-mt-10{margin-top:2.5rem!important}.ag-my-auto{margin-top:auto!important;margin-bottom:auto!important}.ag-px-3-5{padding-left:.875rem!important;padding-right:.875rem!important}.ag-px-0{padding-left:0!important;padding-right:0!important}.ag-py-14{padding-top:3.5rem!important;padding-bottom:3.5rem!important}.ag-pt-0{padding-top:0!important}.ag-pt-5{padding-top:1.25rem!important}.ag-m-0{margin:0!important}.ag-p-0{padding:0!important}\n"], components: [{ type: WrapperComponent, selector: "lib-wrapper", outputs: ["emittedFormInfo"] }], encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ag-form-builder',
                        templateUrl: './ag-form-builder.component.html',
                        styleUrls: ['./ag-form-builder.component.scss'],
                        encapsulation: i0.ViewEncapsulation.None,
                    }]
            }], propDecorators: { emittedForm: [{
                    type: i0.Output
                }] } });

    var InputConfigurationModule = /** @class */ (function () {
        function InputConfigurationModule() {
        }
        return InputConfigurationModule;
    }());
    InputConfigurationModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    InputConfigurationModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationModule, declarations: [InputConfigurationComponent], imports: [i8.CommonModule, i1.ReactiveFormsModule, i2.MatFormFieldModule, i4.MatIconModule, i7.MatInputModule, i5.MatSelectModule, i3.MatButtonModule, i7$1.MatSlideToggleModule], exports: [InputConfigurationComponent] });
    InputConfigurationModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationModule, imports: [[i8.CommonModule, i1.ReactiveFormsModule, i2.MatFormFieldModule, i4.MatIconModule, i7.MatInputModule, i5.MatSelectModule, i3.MatButtonModule, i7$1.MatSlideToggleModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputConfigurationModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [InputConfigurationComponent],
                        imports: [i8.CommonModule, i1.ReactiveFormsModule, i2.MatFormFieldModule, i4.MatIconModule, i7.MatInputModule, i5.MatSelectModule, i3.MatButtonModule, i7$1.MatSlideToggleModule],
                        exports: [InputConfigurationComponent],
                    }]
            }] });

    var ButtonConfigurationModule = /** @class */ (function () {
        function ButtonConfigurationModule() {
        }
        return ButtonConfigurationModule;
    }());
    ButtonConfigurationModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ButtonConfigurationModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationModule, declarations: [ButtonConfigurationComponent], imports: [i8.CommonModule,
            i2.MatFormFieldModule,
            i5.MatSelectModule,
            i1.ReactiveFormsModule,
            i7.MatInputModule,
            i4.MatIconModule,
            i3.MatButtonModule,
            i7$1.MatSlideToggleModule,
            radio.MatRadioModule], exports: [ButtonConfigurationComponent] });
    ButtonConfigurationModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationModule, imports: [[
                i8.CommonModule,
                i2.MatFormFieldModule,
                i5.MatSelectModule,
                i1.ReactiveFormsModule,
                i7.MatInputModule,
                i4.MatIconModule,
                i3.MatButtonModule,
                i7$1.MatSlideToggleModule,
                radio.MatRadioModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonConfigurationModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [ButtonConfigurationComponent],
                        imports: [
                            i8.CommonModule,
                            i2.MatFormFieldModule,
                            i5.MatSelectModule,
                            i1.ReactiveFormsModule,
                            i7.MatInputModule,
                            i4.MatIconModule,
                            i3.MatButtonModule,
                            i7$1.MatSlideToggleModule,
                            radio.MatRadioModule,
                        ],
                        exports: [ButtonConfigurationComponent],
                    }]
            }] });

    var SettingModalModule = /** @class */ (function () {
        function SettingModalModule() {
        }
        return SettingModalModule;
    }());
    SettingModalModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    SettingModalModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalModule, declarations: [SettingModalComponent], imports: [i8.CommonModule,
            i3$1.MatCardModule,
            i2.MatFormFieldModule,
            i6.MatOptionModule,
            i5.MatSelectModule,
            i3.MatButtonModule,
            InputConfigurationModule,
            ButtonConfigurationModule,
            i4.MatIconModule,
            divider.MatDividerModule,
            i11.MatTooltipModule], exports: [SettingModalComponent] });
    SettingModalModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalModule, imports: [[
                i8.CommonModule,
                i3$1.MatCardModule,
                i2.MatFormFieldModule,
                i6.MatOptionModule,
                i5.MatSelectModule,
                i3.MatButtonModule,
                InputConfigurationModule,
                ButtonConfigurationModule,
                i4.MatIconModule,
                divider.MatDividerModule,
                i11.MatTooltipModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: SettingModalModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [SettingModalComponent],
                        imports: [
                            i8.CommonModule,
                            i3$1.MatCardModule,
                            i2.MatFormFieldModule,
                            i6.MatOptionModule,
                            i5.MatSelectModule,
                            i3.MatButtonModule,
                            InputConfigurationModule,
                            ButtonConfigurationModule,
                            i4.MatIconModule,
                            divider.MatDividerModule,
                            i11.MatTooltipModule,
                        ],
                        entryComponents: [SettingModalComponent],
                        exports: [SettingModalComponent],
                    }]
            }] });

    var ButtonModule = /** @class */ (function () {
        function ButtonModule() {
        }
        return ButtonModule;
    }());
    ButtonModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ButtonModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonModule, declarations: [ButtonComponent], imports: [i8.CommonModule, i3.MatButtonModule, i11.MatTooltipModule, i4.MatIconModule, i1$2.RouterModule], exports: [ButtonComponent] });
    ButtonModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonModule, imports: [[i8.CommonModule, i3.MatButtonModule, i11.MatTooltipModule, i4.MatIconModule, i1$2.RouterModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: ButtonModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [ButtonComponent],
                        imports: [i8.CommonModule, i3.MatButtonModule, i11.MatTooltipModule, i4.MatIconModule, i1$2.RouterModule],
                        exports: [ButtonComponent],
                    }]
            }] });

    var InputModule = /** @class */ (function () {
        function InputModule() {
        }
        return InputModule;
    }());
    InputModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    InputModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputModule, declarations: [InputComponent], imports: [i8.CommonModule, i7.MatInputModule, i1.ReactiveFormsModule, i4.MatIconModule, i3.MatButtonModule], exports: [InputComponent] });
    InputModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputModule, imports: [[i8.CommonModule, i7.MatInputModule, i1.ReactiveFormsModule, i4.MatIconModule, i3.MatButtonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: InputModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [InputComponent],
                        imports: [i8.CommonModule, i7.MatInputModule, i1.ReactiveFormsModule, i4.MatIconModule, i3.MatButtonModule],
                        exports: [InputComponent],
                    }]
            }] });

    var WrapperModule = /** @class */ (function () {
        function WrapperModule() {
        }
        return WrapperModule;
    }());
    WrapperModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    WrapperModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperModule, declarations: [WrapperComponent], imports: [i8.CommonModule,
            i3$1.MatCardModule,
            i3.MatButtonModule,
            i7$2.MatGridListModule,
            ButtonModule,
            i4.MatIconModule,
            i11.MatTooltipModule,
            i1$1.MatDialogModule,
            SettingModalModule,
            i2.MatFormFieldModule,
            i7.MatInputModule,
            i1.ReactiveFormsModule,
            InputModule], exports: [WrapperComponent] });
    WrapperModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperModule, imports: [[
                i8.CommonModule,
                i3$1.MatCardModule,
                i3.MatButtonModule,
                i7$2.MatGridListModule,
                ButtonModule,
                i4.MatIconModule,
                i11.MatTooltipModule,
                i1$1.MatDialogModule,
                SettingModalModule,
                i2.MatFormFieldModule,
                i7.MatInputModule,
                i1.ReactiveFormsModule,
                InputModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WrapperModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [WrapperComponent],
                        imports: [
                            i8.CommonModule,
                            i3$1.MatCardModule,
                            i3.MatButtonModule,
                            i7$2.MatGridListModule,
                            ButtonModule,
                            i4.MatIconModule,
                            i11.MatTooltipModule,
                            i1$1.MatDialogModule,
                            SettingModalModule,
                            i2.MatFormFieldModule,
                            i7.MatInputModule,
                            i1.ReactiveFormsModule,
                            InputModule,
                        ],
                        exports: [WrapperComponent],
                    }]
            }] });

    var AgFormBuilderModule = /** @class */ (function () {
        function AgFormBuilderModule() {
        }
        return AgFormBuilderModule;
    }());
    AgFormBuilderModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    AgFormBuilderModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderModule, declarations: [AgFormBuilderComponent], imports: [i8.CommonModule, WrapperModule], exports: [AgFormBuilderComponent] });
    AgFormBuilderModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderModule, imports: [[i8.CommonModule, WrapperModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: AgFormBuilderModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [AgFormBuilderComponent],
                        imports: [i8.CommonModule, WrapperModule],
                        exports: [AgFormBuilderComponent],
                    }]
            }] });

    /*
     * Public API Surface of ag-form-builder
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AgFormBuilderComponent = AgFormBuilderComponent;
    exports.AgFormBuilderModule = AgFormBuilderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ag-form-builder.umd.js.map
